<ng-template #buttonTemplate>
  <button
    (click)="buttonClick.emit()"
    type="button"
    class="custom-button"
    [ngClass]="getButtonClasses()"
  >
    <div class="start-button">
      <span
        *ngIf="startIcon"
        [ngClass]="'icon-color-' + startIconColor"
        aria-hidden="true"
        class="material-symbols-outlined iconStart"
        >{{ startIcon }}</span
      >
      <span
        [ngClass]="{
          'custom-button-text': true,
          'content-font': fontScheme === customButtonFontScheme.content,
        }"
      >
        {{ title }}
      </span>
    </div>
    <span
      *ngIf="endIcon"
      aria-hidden="true"
      class="material-icons-outlined iconEnd"
      >{{ endIcon }}</span
    >
  </button>
</ng-template>

<ng-template #linkTemplate>
  <a
    (click)="onLinkClick($event)"
    class="custom-button"
    [attr.href]="buttonHref ? buttonHref : null"
    [ngClass]="getButtonClasses()"
  >
    <div class="start-button">
      <span
        *ngIf="startIcon"
        [style.color]="startIconColor"
        aria-hidden="true"
        class="material-symbols-outlined iconStart"
        >{{ startIcon }}</span
      >
      <span
        [ngClass]="{
          'custom-button-text': true,
          'content-font': fontScheme === customButtonFontScheme.content,
        }"
      >
        {{ title }}
      </span>
    </div>
    <span
      *ngIf="endIcon"
      aria-hidden="true"
      class="material-icons-outlined iconEnd"
      >{{ endIcon }}</span
    >
  </a>
</ng-template>

<ng-container
  *ngTemplateOutlet="
    buttonType === customButtonType.link ? linkTemplate : buttonTemplate
  "
></ng-container>
